!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!! Class Definition File Contents
!!!!! File Name: sbrf.clw
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

                MEMBER('classes.clw')
                MAP
                END
                INCLUDE('cfcapi.inc'),ONCE
                INCLUDE('CFCComctrl.inc'),ONCE
                INCLUDE('sbrf.inc'),ONCE
                INCLUDE('dynstrclass.inc'), ONCE

_TSB_TestPinpad_        LONG,STATIC,NAME('TSB_TestPinpad')
_TSB_card_authorize7_   LONG,STATIC,NAME('TSB_card_authorize7')
_TSB_close_day_         LONG,STATIC,NAME('TSB_close_day')

cstrTSB_TestPinpad      CSTRING('_TestPinpad')
cstrTSB_card_authorize7 CSTRING('_card_authorize7')
cstrTSB_close_day       CSTRING('_close_day')

SBRFClass.Construct             PROCEDURE
Dll_Name                        CSTRING('pilot_nt.dll')
  CODE
  IF NOT SELF.DllHandle
    SELF.DllHandle = CFC_LoadLibrary(Dll_Name)
    IF SELF.DllHandle
      SELF.FlagLoaded = TRUE
      _TSB_TestPinpad_ = CFC_GetProcAddress(SELF.DllHandle, cstrTSB_TestPinpad)
      IF NOT _TSB_TestPinpad_
        SELF.FlagLoaded = FALSE
      END
      _TSB_card_authorize7_ = CFC_GetProcAddress(SELF.DllHandle, cstrTSB_card_authorize7)
      IF NOT _TSB_card_authorize7_
        SELF.FlagLoaded = FALSE
      END
      _TSB_close_day_ = CFC_GetProcAddress(SELF.DllHandle, cstrTSB_close_day)
      IF NOT _TSB_close_day_
        SELF.FlagLoaded = FALSE
      END
    END
  END

SBRFClass.Destruct              PROCEDURE
  CODE
  IF SELF.DllHandle
    Err# = CFC_FreeLibrary(SELF.DllHandle)
  END
  SELF.FlagLoaded = FALSE

SBRFClass.TestPinpad            PROCEDURE()!,BYTE
  CODE
  IF NOT SELF.FlagLoaded THEN RETURN 0 END
  RETURN CHOOSE(TSB_TestPinpad() = 0, 1, 0)

SBRFClass.Payment               PROCEDURE(REAL Summa)!,BYTE
loc:auth_answer7                GROUP(auth_answer7).
cstr1                            &CSTRING
result                          DynStr
 CODE
 IF NOT SELF.FlagLoaded THEN RETURN 0 END
 SELF.ClearError
 CLEAR(loc:auth_answer7)
 loc:auth_answer7.TType = 1
 loc:auth_answer7.Amount = Summa * 100
 CLEAR(SELF.CardID)
 IF TSB_card_authorize7(0, ADDRESS(loc:auth_answer7)) = 0
   IF loc:auth_answer7.Check
     cstr1 &= (loc:auth_answer7.Check)
     SELF.FileName = SELF.GetTempFileName()
     SELF.WriteFile(SELF.FileName, cstr1)
     CFC_GlobalFree(loc:auth_answer7.Check)
     SELF.CardID = loc:auth_answer7.CardID
     RETURN 1
   ELSE
     SELF.SetError(loc:auth_answer7.RCode)
     RETURN 0
   END
 ELSE
   SELF.SetError(loc:auth_answer7.RCode)
   RETURN 0
 END

SBRFClass.MoneyBack             PROCEDURE(REAL Summa)!,BYTE
loc:auth_answer7                GROUP(auth_answer7).
cstr1                            &CSTRING
result                          DynStr
 CODE
 IF NOT SELF.FlagLoaded THEN RETURN 0 END
 SELF.ClearError
 CLEAR(loc:auth_answer7)
 loc:auth_answer7.TType = 3
 loc:auth_answer7.Amount = Summa * 100
 CLEAR(SELF.CardID)
 IF TSB_card_authorize7(0, ADDRESS(loc:auth_answer7)) = 0
   IF loc:auth_answer7.Check
     cstr1 &= (loc:auth_answer7.Check)
     SELF.FileName = SELF.GetTempFileName()
     SELF.WriteFile(SELF.FileName, cstr1)
     CFC_GlobalFree(loc:auth_answer7.Check)
     SELF.CardID = loc:auth_answer7.CardID
     RETURN 1
   ELSE
     SELF.SetError(loc:auth_answer7.AMessage)
     RETURN 0
   END
 ELSE
   SELF.SetError(loc:auth_answer7.AMessage)
   RETURN 0
 END

SBRFClass.CloseDay              PROCEDURE()!,BYTE
loc:auth_answer                 GROUP(auth_answer).
cstr1                            &CSTRING
result                          DynStr
 CODE
 IF NOT SELF.FlagLoaded THEN RETURN 0 END
 SELF.ClearError
 CLEAR(loc:auth_answer)
 loc:auth_answer.TType = 7
 IF NOT TSB_close_day(ADDRESS(loc:auth_answer))
   IF loc:auth_answer.Check
     cstr1 &= (loc:auth_answer.Check)
     SELF.FileName = SELF.GetTempFileName()
     SELF.WriteFile(SELF.FileName, cstr1)
     CFC_GlobalFree(loc:auth_answer.Check)
     RETURN 1
   ELSE
     SELF.SetError(loc:auth_answer.AMessage)
     RETURN 0
   END
 ELSE
   SELF.SetError(loc:auth_answer.AMessage)
   RETURN 0
 END

SBRFClass.WriteFile             PROCEDURE(STRING FileName, STRING Data)
Gronto                          FILE,DRIVER('DOS'),CREATE
Record                            RECORD
Line                                STRING(1)
                                  END
                                END
DataLen                         LONG,AUTO
  CODE
  Gronto{PROP:Name} = FileName
  CREATE(Gronto)
  OPEN(Gronto)
  DataLen = LEN(CLIP(Data))
  LOOP W# = 1 TO DataLen
    Gronto.Line = Data[W#]
    ADD(Gronto)
  END
  CLOSE(Gronto)

SBRFClass.Loaded                PROCEDURE()!,BYTE
  CODE
  RETURN SELF.FlagLoaded

SBRFClass.ClearError            PROCEDURE
  CODE
  CLEAR(SELF.LastErrorText)

SBRFClass.GetError              PROCEDURE()!,STRING
  CODE
  RETURN SELF.LastErrorText

SBRFClass.SetError              PROCEDURE(STRING Text)
  CODE
  SELF.LastErrorText = Text

SBRFClass.GetFileName           PROCEDURE()!,STRING
  CODE
  RETURN SELF.FileName

SBRFClass.GetTempFileName       PROCEDURE()!,STRING
  CODE
  RETURN CLIP(GLO:CFC_Comctrl.GetTempFileName(GLO:CFC_Comctrl.GetLocalPath(),'CHK'))

SBRFClass.GetCardID             PROCEDURE()!,STRING
  CODE
  RETURN SELF.CardID


